/**
 * Created by Sam R.
 * on 18-12-2011
 * at 22:53
 */
package com.cirrial.ld22 {
import com.cirrial.ld22.PlayState;

import org.flixel.FlxG;

import org.flixel.FlxSprite;
import org.flixel.FlxState;
import org.flixel.FlxText;

public class CutsceneState extends FlxState {
    [Embed(source = '../../../../data/graphics/intro1.png')]
    private var ImgIntro1:Class;
    [Embed(source = '../../../../data/graphics/intro2.png')]
    private var ImgIntro2:Class;
    [Embed(source = '../../../../data/graphics/intro3.png')]
    private var ImgIntro3:Class;

    [Embed(source = '../../../../data/graphics/outro1.png')]
    private var ImgOutro1:Class;
    [Embed(source = '../../../../data/graphics/outro2.png')]
    private var ImgOutro2:Class;
    [Embed(source = '../../../../data/graphics/outro3.png')]
    private var ImgOutro3:Class;

    private var introImages:Array = [
            ImgIntro1,
            ImgIntro2,
            ImgIntro3
    ];

    private var outroImages:Array = [
            ImgOutro1,
            ImgOutro2,
            ImgOutro3
    ];

    private var images:Array;
    private var index:int = 0;

    private var display1:FlxSprite;
    private var display2:FlxSprite;

    private var acceptInput:Boolean = true;
    private var advancing:Boolean = false;

    override public function create():void {
        if(PlayState.transition == 1) {
            images = outroImages;
        }
        else {
            images = introImages;
        }
        index = 0;

        display1 = new FlxSprite(0,0);
        display1.loadGraphic(images[0]);
        add(display1);
        display2 = new FlxSprite(0,0);
        display2.alpha = 0;
        add(display2);

        var advanceText:FlxText = new FlxText(0, 230, Main.SCREEN_WIDTH/Main.ZOOM_LEVEL, "- Press X or C to advance -");
        advanceText.setFormat(null, 8, 0xFFFFFF, "center");
        add(advanceText);

        acceptInput = true;

        FlxG.flash(0xFFFFFFFF, 1.0);
    }

    override public function update():void {
        if((FlxG.keys.justPressed("X") || FlxG.keys.justPressed("C")) && acceptInput) {
            index += 1;
            FlxG.play(SoundData.SndTerminal);
            if(index >= images.length) {
                acceptInput = false;
                if(PlayState.transition == 1) FlxG.fade(0xFFFFFFFF, 1.0, goToWin);
                else FlxG.fade(0xFF000000, 1.0, goToPlay);
            } else {
                display1.loadGraphic(images[index - 1]);
                display1.alpha = 1;
                display2.loadGraphic(images[index])
                display2.alpha = 0;
                advancing = true;
            }
        }
        if(advancing) {
            if(display1.alpha > 0) {
                display1.alpha -= 0.5 * Main.EXPECTED_TIMESTEP;
            }
            if(display2.alpha < 1) {
                display2.alpha += 0.5 * Main.EXPECTED_TIMESTEP;
            }
            if(display1.alpha <= 0 && display2.alpha >= 1) {
                advancing = false;
            }
        }
    }

    private function goToWin():void {
        FlxG.switchState(new WinState());
    }

    private function goToPlay():void {
        FlxG.switchState(new PlayState());
    }
}
}
